/*
 * @FilePath: /cmakeTest/home/wjh/modelTRT/modelTRT_custom_plugin/modelConverter/inc/caffeConverter.hpp
 * @Brief:
 * @Version: 1.0
 * @Date: 2021-03-05 07:21:54
 * @Author: WangJiaHao
 * @Copyright: IChinae(BEIJING) TECH.CO.,LTD.
 * @LastEditors: WangJiaHao
 * @LastEditTime: 2021-03-08 08:02:12
 */
#ifndef CAFFE_CONVERTER_H_
#define CAFFE_CONVERTER_H_
#include"ConverterInterface.hpp"
#include"dataStruct.hpp"
#include<NvCaffeParser.h>
#include"pluginFactory.hpp"
struct CaffeConverterParams: public ConvertParamsInterface
{
    std::string netWorkPath;
};
class CaffeConverter: public ConverterInterface
{
public:
    CaffeConverter()
    {
        pluginFactory.reset(new nvinfer1::ZDXFPluginFactory());
    }
    virtual bool convert()final;
    virtual bool setConvertParams(const std::shared_ptr<ConvertParamsInterface>& params) final;
private:
    nv_unique_ptr< nvinfer1::IBuilder>builder;
    nv_unique_ptr< nvinfer1::INetworkDefinition>network;
    nv_unique_ptr < nvinfer1::IBuilderConfig> config;
    nv_unique_ptr < nvcaffeparser1::ICaffeParser> parser;
    std::unique_ptr<nvcaffeparser1::IPluginFactoryV2> pluginFactory;
};

#endif