/*
 * @FilePath: /cmakeTest/home/wjh/modelTRT/modelTRT_custom_plugin/modelConverter/inc/dataStruct.hpp
 * @Brief:
 * @Version: 1.0
 * @Date: 2021-03-05 05:35:52
 * @Author: WangJiaHao
 * @Copyright: IChinae(BEIJING) TECH.CO.,LTD.
 * @LastEditors: WangJiaHao
 * @LastEditTime: 2021-03-08 06:14:45
 */
#ifndef DATAD_STRUCT_H
#define DATAD_STRUCT_H
#include<memory>
#include<NvInfer.h>
#include<glog/logging.h>
#include<string>
struct NvDeleter
{
    template<typename T>
    void operator()(T* obj)
    {
        obj->destroy();
    }
};

class Logger : public nvinfer1::ILogger
{
    void log(Severity severity, const char* msg) override
    {
        // suppress info-level messages
        if (severity == Severity::kINFO || severity == Severity::kVERBOSE)
            LOG(INFO) << "[LOGGER]" << msg;
        else if (severity == Severity::kERROR)
            LOG(ERROR) << "[LOGGER]" << msg;
        else if (severity == Severity::kWARNING)
            LOG(WARNING) << "[LOGGER]" << msg;
        else if (severity == Severity::kINTERNAL_ERROR)
            LOG(FATAL) << "[LOGGER]" << msg;
        else
            LOG(INFO) << "[LOGGER]" << msg;
    }
} ;
static Logger glogger{};
template<typename T>
using nv_unique_ptr = std::unique_ptr<T, NvDeleter>;

#endif