/*
 * @FilePath: /modelTRT_custom_plugin/modelConverter/src/main.cpp
 * @Brief:
 * @Version: 1.0
 * @Date: 2021-03-05 03:16:55
 * @Author: WangJiaHao
 * @Copyright: IChinae(BEIJING) TECH.CO.,LTD.
 * @LastEditors: Wangjiahao
 * @LastEditTime: 2021-03-15 08:19:14
 */
#include<iostream>
#include<glog/logging.h>
#include<caffeConverter.hpp>
int main(int argc, char** argv)
{
    ::FLAGS_alsologtostderr = 1;
    ::FLAGS_max_log_size = 5;
    ::FLAGS_stderrthreshold =google::INFO;
    google::InitGoogleLogging(argv[0]);
    LOG(INFO) << "testing code";
    auto  params = std::make_shared<CaffeConverterParams>();
    params->netWorkPath = "/home/wjh/models/quality/face_qulity_conv_trt.prototxt";
    params->weightspath = "/home/wjh/models/quality/shufflenet_112_0.5_0623.caffemodel";
    params->name = "quality";
    params->max_work_space_mbi = 1024;
    params->inputlayers = {{"data", {1, 3, 112, 112}}};
    //["conv1","branch1_2_conv1","branch1_2_conv2","concat1","shuffle1","branch2_1","branch2_2","fc_1"]
    params->outputLayers = {{"data",{}},{"conv1",{}},
                                                {"branch1_2_conv1",{}},
                                                {"branch1_2_conv2",{}},
                                                {"concat1",{}},
                                                {"shuffle1",{}},
                                                {"branch2_1",{}},
                                                {"branch2_2",{}},
                                                {"fc_1", {}}};
    CaffeConverter converter{};
    converter.setConvertParams(params);
    if (converter.convert())
    {
        converter.dumpEngine("/home/wjh/models/quality/quality.engine");
    }
    else
    {
        LOG(ERROR) << "[main-test] convert error! see log for full trace";
    }
    google::ShutdownGoogleLogging();


}