/*
 * @FilePath: /modelTRT_custom_plugin/plugins/src/common.cpp
 * @Brief: 
 * @Version: 1.0
 * @Date: 2021-03-09 09:31:38
 * @Author: Wangjiahao
 * @Copyright: IChinae(BEIJING) TECH.CO.,LTD.
 * @LastEditors: Wangjiahao
 * @LastEditTime: 2021-03-10 01:44:43
 */
#include<common.hpp>
#include<glog/logging.h>
std::string print_dim(const nvinfer1::Dims& dims)
{
    std::string res{"("};
    for (int i = 0; i != dims.nbDims; i++)
    {
        res += std::to_string(dims.d[i]);
        if (i ==  dims.nbDims - 1)
        {
            res += ")";
        }
        else
        {
            res += ",";
        }
    }
    return res;
}
size_t GetDBytes(const nvinfer1::DataType dtype)
{
    switch (dtype)
    {
        case nvinfer1::DataType::kBOOL:
        {
            return sizeof(bool);
        }
        case nvinfer1::DataType::kFLOAT:
        {
            return sizeof(float);
        }
        case nvinfer1::DataType::kHALF:
        {
            return sizeof(float) / 2;
        }
        case nvinfer1::DataType::kINT32:
        {
            return sizeof(int);
        }
        case nvinfer1::DataType::kINT8:
        {
            return sizeof(char);
        }
        default:{
            LOG(ERROR)<<"[GetDBytes] unknown datatype:"<<(int)dtype;
            return 0;
        }
    }
}
int DimsCount(const nvinfer1::Dims & dim,int start_axsis,int end_axsis){
    CHECK_LT(start_axsis,end_axsis);
    CHECK_LE(end_axsis,dim.nbDims);
    int res=1;
    for(int i=start_axsis;i!=end_axsis;i++){
        res*=dim.d[i];
    }
    return res;
}
int DimsCount(const nvinfer1::Dims & dim,int end_axsis){
    return DimsCount(dim,0,end_axsis);
}

int DimsCount(const nvinfer1::Dims & dim){
    return DimsCount(dim,0,dim.nbDims);
}